//---------------------------------------------------------------------------
#include <iostream.h>
#include <math.h>

#define max(a, b)  (((a) > (b)) ? (a) : (b))
//---------------------------------------------------------------------------
int main()
{
    float rho1,rho2,r;   //Profitabilities of stocks and a bank interest rate
    float p1,p2;         //Probabilities of profitabilities
    float S0;            //Initial price of the stock
    float fN1,fN2;       //Payment functions at the time moment N=1
    float aux;           //auxiluary variable

    cout<<"Enter initial price of the asset\nS0=";cin>>S0;
    cout<<"Enter profitabilities of the asset\n";
    cout<<"b=";cin>>rho1;
    cout<<"a=";cin>>rho2;
    cout<<"Enter the probability of b\n";
    cout<<"p=";cin>>p1;
    p2=1-p1;
    cout<<"1-p="<<p2<<endl;
    cout<<"Enter interest rate of the bond\nr=";cin>>r;

    aux=((1+r)-1-rho2)/(rho1-rho2);    
    cout<<"\nValue of risk-neutral probability is "<<aux<<endl;

    //evaluation of payment fN
    fN1=max(0,S0*rho1);
    fN2=max(0,S0*rho2);

    //evaluation of "evrictic" price
    cout<<"\"Evristic\" price of this contract is "<<(fN1*p1+fN2*p2)/((1+r))<<endl;

    //evaluation of minimum hedge price
    aux=(fN2*(1+rho1)-fN1*(1+rho2))/((1+r)*(rho1-rho2))+(fN1-fN2)/(rho1-rho2);
    cout<<"Price of the minimum hedge is "<<aux<<","<<endl;
    aux=(fN1-fN2)/(S0*(rho1-rho2));
    cout<<"where intension of stocks is "<<aux<<" and the same of bond capital is "<<(fN1-aux*S0*(1+rho1))/((1+r))<<endl;

    //evaluation of the risk-neutral price
    aux=((1+r)-1-rho2)/(rho1-rho2);
    cout<<"Risk-neutral price is "<<(fN1*aux+fN2*(1-aux))/((1+r))<<endl;

    return 0;
}
//---------------------------------------------------------------------------

