//---------------------------------------------------------------------------
#include <math.h>
#include <iostream.h>

#define max(a,b)  (((a) > (b)) ? (a) : (b))
//---------------------------------------------------------------------------
int main()
{
    float rho1,rho2,r; //Share of the stock increment
    float S0,K;        //Initial price of the stock, price of execution
    float pb;          //Bernoulli probability
    int N;             //Amount of the time steps
    float f,E;         //Auxiluary variables for execution function and the conditional mean

    //Reading of the parameters from the consol
    cout<<"Enter initial price of the stock"<<endl;
    cout<<"S0=";cin>>S0;
    cout<<"Enter profitabilities of the stock"<<endl;
    cout<<"b=";cin>>rho1;
    cout<<"a=";cin>>rho2;
    cout<<"Enter interst rate of the bond"<<endl;
    cout<<"r=";cin>>r;
    cout<<"Enter execution price of the contract"<<endl;
    cout<<"K=";cin>>K;
    cout<<"Enter terminal moment of time"<<endl;
    cout<<"N=";cin>>N;

    float *Y=new float[N];
    float *S=new float[N];
    pb=(r-rho2)/(rho1-rho2);

    //------------------------The first step-----------------------------------
    //Initialization of the stock prices
    for(int i=0;i<N;i++){
    	S[i]=S0*pow(1+rho1,N-i-1)*pow(1+rho2,i);
    	f=max(0,S[i]-K)/pow(1+r,N-1);
        E=(max(0,S[i]*(1+rho1)-K)*pb+max(0,S[i]*(1+rho2)-K)*(1-pb))/pow(1+r,N);
        Y[i]=max(f,E);
    }

    //The second step
    for(int k=N-1;k>=2;k--){
        for(int i=0;i<k;i++){
            S[i]=S0*pow(1+rho1,k-i-1)*pow(1+rho2,i);
            f=max(0,S[i]-K)/pow(1+r,k-1);
		    E=Y[i]*pb+Y[i+1]*(1-pb);
            Y[i]=max(f,E);
        }
    }

    //The last step
    f=max(0,S0-K);
    E=Y[0]*pb+Y[1]*(1-pb);
    cout<<"\n\nFair value of the option is "<< max(f,E)<<endl;

    return 0;
}
//---------------------------------------------------------------------------




